package org.azzyzt.jee.runtime.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.azzyzt.jee.runtime.meta.AzzyztGeneratorCutback;
import org.azzyzt.jee.runtime.meta.AzzyztGeneratorOption;

/**
 * <p>This annotation can be used on <code>Azzyztant</code>, 
 * the generated class that can be modified to request customizations to 
 * the code generated by Azzyzt JEE Tools.</p>
 * @see org.azzyzt.jee.runtime.meta.AzzyztGeneratorCutback
 * @see org.azzyzt.jee.runtime.meta.AzzyztGeneratorOption
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(value=ElementType.TYPE)
public @interface AzzyztGeneratorOptions {
	
	/**
	 * @return an array of <code>AzzyztGeneratorCutback</code>, 
	 * i.e. requests to <strong>not generate</strong> code that would 
	 * normally <strong>be</strong> generated. Cutbacks are optional.
	 */
	AzzyztGeneratorCutback[] cutbacks() default {};
	
	/**
	 * @return an array of <code>AzzyztGeneratorOption</code>, 
	 * i.e. requests to <strong>generate</strong> code that would 
	 * normally <strong>not be</strong> generated. Options are optional.
	 */
	AzzyztGeneratorOption[] options() default {};

}
